
class CCpkFile : public CFile
{
	struct SoundDescription
	{
		BYTE	reserved,
				numChannels,	// 1 = Monaural, 2 = Stereo
				numBitsSampled,
				compression;	// 0 = None, 1 = ADPCM
	};

	struct ChromaKey
	{
		BYTE	flag,			// 0 = Ignore chromakeying, 1 = Process chromakey
				blue,
				green,
				red;
	};
	
	struct FileHeader
	{
		DWORD	atomID,			// 'FILM'
				atomSize,		// sizeof(FileHeader) + sizeof(FrameDescription) + sizeof(FilmSampleTable) + n*sizeof(FilmSample)
				version,		// '1.09'
				reserved;
	};

	struct FrameDescription
	{
		DWORD	atomID,			// 'FDSC'
				atomSize,		// sizeof(FrameDescription)
				cType,			// compression type 'cvid'
				height,
				width;
		SoundDescription
				soundDesc;
		DWORD	samplingRate;
		ChromaKey
				chromaKey;
	};

	struct FilmSampleTable
	{
		DWORD	atomID,			// 'STAB'
				atomSize,		// sizeof(FilmSampleTable) + n*sizeof(FilmSample)
				timeScale,
				numSamples;		// number of frames and sound samples
	};

	struct FilmSample
	{
		DWORD	start,
				size,
				time,
				duration;
	};

	DWORD				m_sampleIndex,
						m_sampleTime,
						m_frameRate,
						m_frameScale,
						m_remainingAudioTime,
						m_remainingAudioBytes,
						m_dwSampleTablePosition;
	FileHeader			m_fileHdr;
	FrameDescription	m_frameDesc;
	FilmSampleTable		m_sampleTable;
	FilmSample		*	m_pSamples;

public:	
	CCpkFile();
	~CCpkFile();

public:
	void	OpenStreams(void);
	void	CloseStreams(void);
	void	SetVideoInfo( DWORD numFrames, DWORD frameRate, DWORD frameScale, BITMAPINFO& bmi);
	void	SetAudioInfo( DWORD numSamples, WAVEFORMATEX& wav);
	void	WriteHeader(void);
	void	WriteVideoStream( char* pBmi, DWORD cBytes);
	void	WriteAudioStream( char* pBuf, DWORD cBytes);
};
